* programme : AQhms2.s : donne l'anne, le quantieme et l'heure courante.
* PRINCIPE: On installe un serveur d'interruption sur le blanc vertical (VBL) 
* pour asservir l'horloge. On utilitse la fonction Wait() qui permet de faire
* de grandes conomies de CPU.
* version 1.1
* derniere modif : 18 Aout 1992 :prise en compte de la frequence du VBL
*                  et amlioration du contraste.
* fait sous Devpac 2.15 sur A500 (512k Chip, 512k Fast) sys 1.3. 
* par Tilagone Christophe (2 rue Jean le Bail 87100 Limoges (FRANCE))

	opt o+,ow+	; optims maximales + messages warning

*	incdir	"devpac2:include/"
	incdir	"rad:"	; si assez de ram
	include	"exec/execbase.i"
	include	"exec/nodes.i"
	include	"exec/interrupts.i"
	include	"exec/memory.i"
	include	"exec/exec_lib.i"
	include	"intuition/intuition.i"
	include	"intuition/intuition_lib.i"
	include	"graphics/rastport.i"
	include	"graphics/graphics_lib.i"
	include	"graphics/text.i"
	include	"hardware/intbits.i"
	include	"misc/easystart.i"	

Modes	equ RP_JAM2	; mode d'affichage
FontY	equ 8		; hauteur/largeur de la font.

PrgTask	equ 0		; offsets divers pour le
PrgSig	equ 4		; programme d'IT
PrgData	equ 8
				
*================= Chercher tche ==========================
Task	move.l	a4,MyTask	; recuperer pointeur sur tche
				; voir "easystart.i"
VBLFrq	move.l	_SysBase,a6	; SysBase, pour la frequeceVBL
	move.b	VBlankFrequency(a6),FullSec
	move.b	VBlankFrequency(a6),VBLFreq

*================= Allocation d'un signal ==================
AllocSig	moveq	#-1,d0		; demander signal ...
	CALLEXEC	AllocSignal	; quelconque au systeme
	move.b	d0,MySignal	; le stocker 
	bmi	NoSig		; d0 < 0 : pas de signal
SigMask	moveq	#1,d1		; faire le masque d'IT du
	rol.l	d0,d1		; signal allou (mask partiel)
	move.l	d1,MaskSig	; stockage

*================= Ouverture de la librairie ===============	
Main	lea 	IntName(pc),a1	; intuition.library
	CALLEXEC OldOpenLibrary	; sous une version quelconque
	move.l	d0,_IntuitionBase	; stocker le pointeur
	beq	NoInt		; damned ou est elle ?

*================= Ouverture de la fenetre =================	
Win	lea	myNewWindow(pc),a0
	CALLINT	OpenWindow
	move.l	d0,WindowPtr	; recuperer pointeur
	beq	NoWin		; ouverture rate

*================= Allocation mmoire pour serveur =========
AllocSer	moveq	#IS_SIZE,d0	; taille du serveur d'IT
	move.l	#(MEMF_CLEAR|MEMF_PUBLIC),d1
	CALLEXEC	AllocMem
	move.l	d0,Serveur	; sauver pointeur
	beq	NoServ		; pas de ram pour le serveur

*================= Masque Total d'Interruption =============
IntMask	movea.l	WindowPtr(pc),a0	; chercher masque fenetre
	move.l	wd_UserPort(a0),a0
	moveq	#1,d0		; car 1L<<mp_SigBit : d0<<d1
	clr.l	d1
	move.b	MP_SIGBIT(a0),d1
	rol.l	d1,d0		; masque de la fenetre
	or.l	MaskSig,d0	; fusion avec masque du  signal
	move.l	d0,TotalSig	; stockage du masque final
	
*================= Installation du serveur d'IT ============		
CreatSer	movea.l	Serveur(pc),a1
	move.b	#NT_INTERRUPT,LN_TYPE(a1)
	move.b	#-34,LN_PRI(a1)	; priorit
	move.l	#WdTitle,LN_NAME(a1)	; nom
	move.l	#DataInt,IS_DATA(a1)	; donnes connus de l'IT
	move.l	#ProgInt,IS_CODE(a1)	; programme d'IT
	moveq	#INTB_VERTB,d0	; type de l'interruption
	CALLEXEC	AddIntServer	; ajouter le serveur 

*================= Attendre message de fermeture ===========
WaitInt	move.l	TotalSig(pc),d0
	CALLEXEC	Wait		; attendre un signal
	cmp.l	MaskSig(pc),d0	; discrimination
	bne.s	Message		; donc  : CloseWindow
	bsr	TmpSys		; sinon : heure systeme
	bra.s	WaitInt

Message	movea.l	WindowPtr(pc),a0
	movea.l	wd_UserPort(a0),a0
	CALLEXEC	GetMsg		; un message (closewindow) ?
	movea.l	d0,a1		; oui --> y rpondre
	CALLEXEC	ReplyMsg

*================= Libration des ressources ===============
Fin	movea.l	Serveur(pc),a1
	moveq	#INTB_VERTB,d0
	CALLEXEC	RemIntServer	; retirer le serveur
	movea.l	Serveur(pc),a1
	moveq	#IS_SIZE,d0
	CALLEXEC	FreeMem		; librer sa mmoire
NoServ	movea.l	WindowPtr(pc),a0
	CALLINT	CloseWindow	; fermer la fenetre
NoWin	movea.l	_IntuitionBase(pc),a1	
	CALLEXEC	CloseLibrary	; fermer l'intuition
NoInt	move.l	MySignal(pc),d0	; n du signal allou
	CALLEXEC	FreeSignal	; librer le signal
NoSig	moveq	#0,d0		; code de retour 
	rts			; adieu monde cruel

*================= Programme d'Interruption ================
ProgInt	subq.b	#1,PrgData(a1)	; Decrmenter FullSec
	bne.s	Suite		; seconde non coule
	move.b	VBLFreq(pc),PrgData(a1) ; recharger compteur temps
	move.l	PrgSig(a1),d0	; chercher signal a emettre
	movea.l	PrgTask(a1),a1	; tache a prvenir
	CALLEXEC	Signal		; prvenir tche mre
Suite	moveq	#0,d0		; annuler flag Z du SR
	rts			; RTS car le systeme fera le RTE

*================= Recherche du temps ======================	
TmpSys	lea	Sys_Sec(pc),a0	; secondes systeme
	lea	Sys_MicSec(pc),a1	; secondes systeme
temps	CALLINT	CurrentTime	; chercher le temps systeme
	move.l	(a0),d0		; Recuperer "Seconds"
	sub.l	TotalSec(pc),d0	; y soustraire le compteur AnnesSeconde 
	cmp.l	SecAn(pc),d0	; peut on faire une autre anne ?
	bmi.s	SysHexa		; non; ne pas refaire calcul An		

	move.l	#1978,d1		; Date de dpart de l'horloge
IsBissex	move.l	d1,d2
	divu	#4,d2		; chercher "bissextilit"
	andi.l	#$FFFF0000,d2	; si  an /4 alors bissex
	bne.s	NoBissex
Bissex	move.l	#(366*24*3600),d3	; anne bissextile
	bra.s	NextAn
NoBissex	move.l	#(365*24*3600),d3	; anne normale
NextAn	cmp.l	d3,d0		; peut on faire une autre anne ?
	blt.s	NoNextAn		;  non
	sub.l	d3,d0		;  oui
	add.l	d3,TotalSec	; maj compteur de sec depuis 1978
	addq	#1,d1		; mise  jour compteur annes
	bra.s	IsBissex
NoNextAn	move.w	d1,AQHMS		; stocker Anne
	move.l	d3,SecAn		; stocker nb de secondes dans l'anne
	
SysHexa	lea	2+AQHMS(pc),a0	; pointer sur le Quantime
	divu	#3600,d0		; anne en Heures
	swap	d0		; recupere s < 3600
	clr.l	d1
	move.w	d0,d1		; d1 = s < 3600
	clr.w	d0		; eliminer les s
	swap	d0		; reprendre les h
QH	divu	#24,d0		; chercher le nb de jours
	addq.w	#1,d0		; 1er jour = 1er et non 0em
	swap	d0
	move.l	d0,(a0)+		; stocker Quantieme,Heure
MS	divu	#60,d1
	swap	d1
	move.l	d1,(a0)		; stocker Minute,Seconde

*================= Conversion en ASCII =====================
HexASCII	lea	Format(pc),a0	; ptr sur format des valeurs
	lea	AQHMS(pc),a1	; ptr sur chaine hexa a convertir
	lea	PutChar(pc),a2	; ptr sur fonction de remplissage
	lea	Chaine(pc),a3	; ptr chaine de stockage
	CALLEXEC	RawDoFmt
	bra.s	Affiche		; afficher le resultat

PutChar	move.b	d0,(a3)+		; remplir la chaine
	rts

*================= Affichage de la date ====================	
Affiche	movea.l	WindowPtr(pc),a0
	movea.l	wd_RPort(a0),a0	; chercher le RastPort 
	moveq	#0,d0		; x
	moveq	#1,d1		; y
	lea	IntuitionText(pc),a1
	CALLINT	PrintIText	; Affichons
	rts			; retour a WaitInt

*================= Variables ===============================	
Sys_Sec		dc.l 0
Sys_MicSec	dc.l 0	
_IntuitionBase	dc.l 0
IntName		dc.b "intuition.library",0
	even
Serveur		dc.l 0		; pointeur sur serveur
TotalSig		dc.l 0		; masque total d'IT
MySignal		dc.b 0		; signal allou
	even
DataInt				; donnes du prg d'IT
MyTask		dc.l 0		; ptr sur cette tche
MaskSig		dc.l 0		; masque du Signal allou
FullSec		dc.b 0		; compteur de temps	
	even
IntuitionText	dc.b 3,2,Modes,0  ; color texte & fond,mode,alignement
		dc.w 2,10	; x,y
		dc.l 0,Chaine,0	; fonte8,ptr chaine, pas de suite
Format		dc.b  " %4d/%3d-%2d:%2d:%2d ",0
	even
AQHMS	        dcb.w 5,0		; table stockage du temps			
TotalSec		dc.l 0		; nb Secondes depuis 01/01/1978 0h0mn0s
SecAn		dc.l 0		; nb de secondes dans anne en cours
Chaine	        dcb.b (Format-IntuitionText)
		dc.b 0		; 0 terminal

WindowPtr	dc.l 0		; Pointeur sur fenetre	
myNewWindow	dc.w 350,12	; x,y
		dc.w FontY*(Format-IntuitionText-1)+4 ; largeur
		dc.w 10+2+FontY+1	; hauteur
		dc.b 2,1		; couleur texte,fond du titre
		dc.l CLOSEWINDOW	; flag idcmp
		dc.l WINDOWDRAG|WINDOWCLOSE|RMBTRAP|WINDOWDEPTH
		dc.l 0		; pas de gadget personnel
		dc.l 0		; checkmark standard
		dc.l WdTitle	; pointeur sur le titre
		dc.l 0		; pas d'cranperso
		dc.l 0		; pas de bitmap perso
		dc.w 0,0,0,0	; Lmin,Hmin,Lmax,Hmax
		dc.w WBENCHSCREEN	; fenetre sur le WorkBench

WdTitle		dc.b "AQhms",0	; titre de la fenetre
VBLFreq		dc.b 0		; frequence du VBL
	end

