* Programme : AutoDir2.s, affiche le contenu d'une disquette introduite
* en df0:. Ce programme se contente d'afficher que le premier niveau de
* la disquette. Les repertoires sont affichs dans la couleur 3 (orange)
* et les fichiers dans la couleur 1 (blanc).
* maj    : Lundi 16 Juin 1992.
* auteur : Tilagone Christophe . 2 rue Jean le Bail 87100 Limoges.
* 	  tel : 55 50 79 91.
* fait sur le systeme 1.3 avec Devpac 2.15 .

* PRINCIPE : on ouvre les librairies dos et intuition, puis on demande
* de la place sur la PILE du programme pour le FileInfoBlock et pour le
* fichier des noms a afficher par la suite. Aprs on ouvre une fenetre 
* d'attente et on guette un intuimessage. A la reception d'un message on
* l'analyse et le traite en consequence.
* J'utilise la pile pour le fib et le fichier des noms car celle ci fait
* d'une part 4ko (par dfaut) et d'autre part elle n'est que peu utilise
* par le programme (les RKMs du systme 1.3 recommandent une pile minimum
* de 1.5ko). Donc il nous reste 2.5ko pour nous. On doit cependant veiller
* a ce que la pile soit d'au moins 4ko (voir avec stack). Attention, la
* valeur de l'adresse du FileInfoBlock doit absolument etre PAIR EST MULTIPLE
* de 4 car la DOS.library est ecrite en BCPL (une idiotie).  
* On ne peut mmoriser que NbNmTxt noms dans le fichier, si l'on dpasse
* cette valeur alors le fichier se terminera par un "...OVERFLOW...". Il
* est peu probable que l'on voit un jour ce message si vos disquettes sont 
* bien organises.  
* On peut apporter de amliorations au programme par passage des parametres
* concernants par exemples le drive, le nombre de noms a afficher sur la 
* fenetre et la nombre de cararactres par nom. Ceci est a votre charge car,
* je souhaitais seulement visualiser le 1er niveau de la disquette sans 
* ouvrir obligatoirement un Shell (le WB 1.3 ne visualie pas les fichiers 
* dpourvus d'icone). 

	opt	o+,ow-

	incdir	"devpac2:include/"
	include	"intuition/intuition.i"
	include	"intuition/intuition_lib.i"
	include	"libraries/dos.i"
	include	"libraries/dos_lib.i"
	include	"exec/exec_lib.i"
	include	"graphics/rastport.i"
	include	"misc/easystart.i"

NmSize	equ 14			; NmSize char par nom (doit etre pair)
NmLength	equ NmSize+2		; NmSize+1+1 char (0 + couleur) 
NbWdName	equ 14			; nombre de noms a afficher
WinWidth	equ 8*NmSize+8		; largeur de la fenetre
NbNmTxt	equ 120			; NbNmTxt noms dans le fichier
FibLen	equ fib_SIZEOF+2		; taille d'un FileInfoBlock
Modes	equ RP_JAM2		; mode d'affichage
TxtSize	equ NmLength*NbNmTxt 	; taille du fichier des noms (2ko maxi)
GdgHaut	equ 10			; hauteur du gadget
LgnHaut	equ 9			; hauteur d'une ligne

*================== Programme Principal ====================
IntLib	lea	IntName(pc),a1	; ouvrir l'intuition.library
	CALLEXEC	OldOpenLibrary
	move.l	d0,_IntuitionBase	; stocker le ptr sur la bib
	beq	NoInt		; pas de bib ?
DosLib	lea	DosName(pc),a1	; ouvrir la dos.library
	CALLEXEC	OldOpenLibrary
	move.l	d0,_DOSBase	; stocker le ptr sur la bib
	beq	NoDos		; pas de dos ?
FibMem	link	a4,#-FibLen	; demander FibSize octets sur la pile
	move.l	a4,Old_A4	; stocker le registre de linkage 
	movea.l	a7,a4		; pointer en bas de mem reserve
	move.l	a7,d0
	andi.l	#$03,d0		; voir si adresse multiple de 4 
	beq.s	TxtMem		; oui
	adda.l	#2,a4		; non, la rendre multiple de 4
TxtMem	link	a5,#-TxtSize	; TxtSize octets sur la pile
	move.l	a5,Old_A5	; Old_A5 servira a  unliker.
	movea.l	a7,a5		; pointer le bas de la ram rserve.
OpenWin	lea	myNewWindow(pc),a0
	CALLINT	OpenWindow	; ouverture de la fenetre d'attente
	move.l	d0,WindowPtr	; stocker le pointeur
	beq	NoWin		; pas de fenetre
	movea.l	d0,a0		; chercher et stocker l'UserPort
	move.l	wd_UserPort(a0),WinUserPort

WaitWin	movea.l	WinUserPort(pc),a0
	CALLEXEC	WaitPort		; attendre un message
	movea.l	WinUserPort(pc),a0
	CALLEXEC	GetMsg		; le retirer de la file
	movea.l	d0,a1
	move.l	im_Class(a1),d2	; extraire le code utile
	move.w	im_MouseX(a1),d3	: d3 : pour identification du gadget
	CALLEXEC	ReplyMsg		; rpondre au message

SortMsg	cmp.l	#CLOSEWINDOW,d2	; identification du message
	beq.s	FinProg		; --> closewindow
NoClose	cmp.l	#GADGETDOWN,d2
	bne.s	NoGdDown
	bsr	GadgetON		; --> gadgetdown
	bsr	Delais
	bsr	Affiche		; oui, modifier l'affichage
	bra.s	WaitWin
NoGdDown	cmp.l	#DISKINSERTED,d2
	bne.s	NoDskIn		; --> diskinserted
LockOn	move.l	Drive(pc),d1	; obtenir une demande d'accs au drive
	moveq	#ACCESS_READ,d2	; de la part du systeme 
	CALLDOS	Lock
	move.l	d0,LockBase	; stocker le lock
	beq.s	WaitWin		; demande rejete
	bsr	DiskON		; construire le fichier des noms
LockOff	move.l	LockBase(pc),d1	; librer le lock sur le drive
	CALLDOS	UnLock
	bsr	BigWin
	bsr	Delais
	movea.l	a5,a2		; ptr sur le 1er nom
	bsr	Affiche		; afficher les noms
	bra	WaitWin
NoDskIn	bsr	DiskOFF		; --> dikremoved
	bra	WaitWin

FinProg	movea.l	WindowPtr(pc),a0
	CALLINT	CloseWindow	; fermer la fenetre
NoWin	movea.l	Old_A5(pc),a5
	unlk	a5		; liberer la pile du fichier des noms
	movea.l	Old_A4,a4
	unlk	a4		; liberer la pile du FileInfoBlock
	movea.l	_DOSBase(pc),a1
	CALLEXEC	CloseLibrary	; fermer la DOS
NoDos	movea.l	_IntuitionBase(pc),a1
	CALLEXEC	CloseLibrary	; fermer l'Intuition
NoInt	moveq	#0,d0		; code de retour
	rts			; adieu 68000

*================== GadgetON ===============================
* donne		: a3,a5,NbWdName,MnLength,CmptFile,d3
* donne modifie	: a2,d0
* variable locale : d1 
* traitement	: ajuste a2 pour afficher NbWdName noms nouveaux
* 		  (si possible) dans la fenetre. 

GadgetON	cmpi.b	#NbWdName,CmptFile
	bgt.s	RunGdON		; si + de NbWdName on peut agir.
	movea.l	a5,a2		; sinon pointer le haut du fichier
	bra.s	ExitGdON		; on peut scroller si plus de NbWdName
	
RunGdON	move.l	#(NbWdName*NmLength),d0
	move.l	#-(NbWdName*NmLength),d1
	cmp.w	#(WinWidth/2),d3	; identifier l'action
	bgt.s	UPgdt		; on monte dans le fichier

DOWNgdt	lea	(a2,d0.l),a0	; cmpa.l 0(a2,d0.l),a3 non mul ????
	cmpa.l	a0,a3		; il y a un cafard dans le devpac 2.15
	bge.s	ExitGdON		; oui (on peut descendre)
	lea	(a3,d1.l),a2	; non, afficher les derniers NbWdName
	bra.s	ExitGdON
UPgdt	lea	(a2,d1.l),a2	; pointer le dbt du texte dja afficher
	lea	(a2,d1.l),a2	; pour remplacer cmpa.l 0(a2,d1.l),a5
	cmpa.l	a2,a5		; peut on monter de NbWdName char ?
	blt.s	ExitGdON		; non
Top	movea.l	a5,a2		; pointer le haut du fichier
ExitGdON	rts

*================== Delais =================================
* donne		: sans
* donne modifie	: d1
* traitement	: attente de d1/50 seconde, permet un bon affichage

Delais	moveq	#4,d1
	CALLDOS	Delay
	rts

*================== Affiche ================================
* donne		: NbWdName, CmptFile. 
* donne modifie	: a2, StructIntuiText. 
* traitement	: affiche NbWbName sur la fenetre a partir d'a2.

Affiche	clr.l	d1		; ordonne partielle du texte
	clr.l	d3
	moveq	#(NbWdName-1),d2	; (d)compteur du nb de lignes fenetre
	move.b	CmptFile(pc),d3	; compteur du nb de nom dans le fichier 
	lea	StructIntuiText(pc),a1
	move.w	#2,it_TopEdge(a1)	; se placer en dbut de fenetre

RunAffi	movea.l	WindowPtr(pc),a0
	movea.l	wd_RPort(a0),a0
	lea	StructIntuiText(pc),a1
	addi.w	#LgnHaut,it_TopEdge(a1)	; sauter une ligne
	moveq	#0,d0		; abscisse partielle du texte
	move.b	(NmSize+1)(a2),it_FrontPen(a1)
	move.l	a2,it_IText(a1)	; pointeur sur le texte
	CALLINT	PrintIText
	lea	NmLength(a2),a2	; pointer prochain nom
	subq.b	#1,d3		; dcompter une ligne
	beq.s	ExitAffi		; toute la fenetre occupe, on sort
	dbf	d2,RunAffi	; reboucler tant que pas d2 noms afichs
ExitAffi	rts

*================== DiskON =================================
* donnes	: LockBase,a5,NbNmTxt.
* donnesModifies: a3
* rsultat	: CmptFile.
* traitement	: constitution du fichier des noms a afficher.

DiskON	move.l	LockBase(pc),d1
	move.l	a4,d2		; ptr sur le fib
	CALLDOS	Examine
	tst.l	d0		; Examine rat ?
	beq.s	ExitDkON		; oui, on sort

RunDkOn	movea.l	a5,a3		; init du ptr en dbt du fichier
	clr.b	CmptFile		; reset du compteur de fichier

NextFile	lea	fib_FileName(a4),a2
	move.l	LockBase(pc),d1
	move.l	a4,d2		; pointeur sur le fib
	CALLDOS	ExNext		; chercher prochain nom
	tst.l	d0
	beq.s	ExitDkON		; plus de fichier
	cmpi.b	#NbNmTxt,CmptFile	; plus de NbNmTxt noms dans le fichier
	beq.s	CopyErr

	moveq	#NmSize,d0	; NmSize char a recopier
CopyChar	move.b	(a2)+,(a3)+	; copier un char
	dbeq	d0,CopyChar	; reboucler tant que pas NmSize
	tst.b	d0		; NmSize char copis ?
	bmi.s	EndStrg		; oui ajouter le 0 et la couleur
	suba.l	#1,a3		; corriger ptr sur fichier
White	move.b	#" ",(a3)+	; completer avec des " "
	dbeq	d0,White
EndStrg	move.b	#0,-1(a3)	; ajouter le 0 terminal
	tst.l	fib_DirEntryType(a4)
	bge.s	Dir
File	move.b	#1,(a3)+		; 1: blanc : fichier
	bra.s	CountFil
Dir	move.b	#3,(a3)+		; 3: orange: repertoire
CountFil	addi.b	#1,CmptFile	; ajouter UN fichier
	bra.s	NextFile
	
CopyErr	suba.l	#NmLength,a3	; remonter sur le dernier nom
	moveq	#(NmLength-1),d0
	lea	OverFlow(pc),a0
OverMsg	move.b	(a0)+,(a3)+	; recopier le message de dpassement
	dbf	d0,OverMsg
	
ExitDkON	rts

*================== BigWin =================================
* donne		: WindowPtr
* traitement	: agrandissement de la fenetre d'attente et mise a 
*		  jour des IDCMP de cette nouvelle fenetre 

BigWin	move.l	#(CLOSEWINDOW|DISKREMOVED|GADGETDOWN),d0
	movea.l	WindowPtr(pc),a0
	CALLINT	ModifyIDCMP

	moveq	#0,d0		; largeur puis hauteur
	move.l	#(LgnHaut*NbWdName+2),d1
	move.l	WindowPtr(pc),a0
	CALLINT	SizeWindow
	rts

*================== DiskOFF ================================
* donne		: sans.
* traitement	: affiche la fenetre d'attente aprs retrait d'un disk

DiskOFF	move.l	#(DISKINSERTED|CLOSEWINDOW),d0
	movea.l	WindowPtr(pc),a0
	CALLINT	ModifyIDCMP
	
	moveq	#0,d0
	move.l	#-(LgnHaut*NbWdName+2),d1
	movea.l	WindowPtr(pc),a0
	CALLINT	SizeWindow	; afficher la fenetre d'attente
ExitDkOf	rts

*================== variables ==============================
_DOSBase		dc.l 0			; pointeur sur la dos.library
_IntuitionBase	dc.l 0			; pointeur sue l'intuition
WindowPtr	dc.l 0			; pointeur sur la fenetre
WinUserPort	dc.l 0			: pointeur sur le port d'attente
Old_A4		dc.l 0			; pour unliker 
Old_A5		dc.l 0			; pour unliker
LockBase		dc.l 0			; pour fonctions Examine,ExNext,UnLock.
CmptFile		dc.b 0			; cmpt du nb de file(s) de la disquette
	even
IntName		dc.b "intuition.library",0
DosName		dc.b "dos.library",0
	even
OverFlow		dc.b "..OVERFLOW....",0,3	; message de dbordemeent
	even
Drive		dc.b "DF0:",0		; drive a lire
	even
myNewWindow	dc.w 360,12		; position x et y
		dc.w WinWidth,10+GdgHaut	; largeur, hauteur
		dc.b 2,1			; couleur texte et fond
		dc.l CLOSEWINDOW|DISKINSERTED
		dc.l WINDOWDRAG|WINDOWCLOSE|RMBTRAP|WINDOWDEPTH
		dc.l StructGadget		; pointeur sur gadget personnel
		dc.l 0			; checkmark : standard
		dc.l Drive		; ptr sur nom de la fenetre
		dc.l 0			; pas d'ecran personnel
		dc.l 0			; pas de bitmap personnelle
		dc.w WinWidth,10+GdgHaut	; Lmin,Hmin
		dc.w WinWidth,190+GdgHaut	; Lmax,Hmax
		dc.w WBENCHSCREEN		; fenetre sur le WBench 

StructIntuiText	dc.b 0,0,Modes,0
		dc.w 4,2			; x,y
		dc.l 0,0,0

StructGadget	dc.l 0			; pas d'autre gadget
		dc.w 0,-GdgHaut		; X,Y
		dc.w WinWidth-10,GdgHaut	; largeur, hauteur HitBox
		dc.w GADGHNONE|GRELBOTTOM	; Flags
		dc.w GADGIMMEDIATE	; actif au clic
		dc.w BOOLGADGET		; gadget boolen
		dc.l StructGadBorder	; ptr sur l'apparence
		dc.l 0			; pas de 2nd image
		dc.l GadgIntuiText	; texte associ
		dc.l 0			; pas d'exclude
		dc.l 0			; pas de specialInfo
		dc.w 0			; gdget n 0
		dc.l 0			; pas de data personnel
StructGadBorder	dc.w 0,0			; x,y: pas d'offset
		dc.b 1,0			; couleurs 
		dc.b RP_JAM1		; mode d'affichage
		dc.b 2			; 1 ligne: 2 points
		dc.l StructBords		; ptr sur la tableau des bords 
		dc.l 0			; pas d'autre border	
GadgIntuiText	dc.b 1,0,Modes,0
		dc.w 4,2			; x,y
		dc.l 0,GadgetTexte,0
GadgetTexte	dc.b " DOWN  |  UP  ",0

	section	Contours,DATA_C
StructBords	dc.w 0,0
		dc.w WinWidth,0

	end

