* Programme : Copper.s : il affiche quelques barres copper sur le fond de
*                        l'cran du WorkBench.

* fait le 28 Aout 1992 sur Devpac2.15. 
*	systeme 1.3, 512ko Fast, 512 ko Chip.
* auteur: TILAGONE Christophe, 2 rue Jean le Bail 87100 Limoges FRANCE.
*	 tel : 55 50 79 91

* Le but de ce programme est simplement d'exploiter le copper par l'assembleur;
* ceci bien sur tout en RESPECTANT le SYSTEME. Bien qu'il existe des faons 
* plus rapides (copperlist dclare comme une datas) mais un peut "sauvages".
* D'accord, ce programme peut etre optimiser un poil mais, comme je souhaitai
* seulement dcouvrir et exploiter les instructions du Copper j'ai fait le plus
* clair possible.  
* Ainsi on decouvre qu'aprs une instruction d'attente (WAIT) ou d'insertion
* (MOVE) on doit coincer un BUMP (pour passer l'instruction suivante).
* De plus la copperlist doit etre termine par un "CEND" qui n'est autre que
* l'attente d'une position qui n'arrivera jamais.
* Si vous voulez modifier les couleurs (en valeur ou en nombre) il faudra 
* respecter les conditions suivantes : une couleur et code sur un mot (.w)
* comme suit:  x,R,V,B. R,V,B compris entre 0 et F; x = 0. Pour modifier le
* nomdre de couleur, il faut d'une part modifier la constante NbBarre (ici on
* a une barre par couleur) et d'autre part verifier que la table "Couleurs" 
* soit suffisemment fournie.

* mais KICETI "Copper"? Dirons les novices. Copper est le dernier processeurs
* de la chaine des coprocesseurs graphiques de l'AMIGA. C'est lui qui determine
* la couleur d'un point a l'cran. Il est en parfaite harmonie avec le rayon
* electronique balayant l'cran. Donc, la bte est la dernire a parler, elle
* peut donc modifier les couleurs de l'cran. Pour ce faire, elle utilise des
* "CopperList". Il existe deux grandes sortes de CopperList: celles produitent 
* par le systeme et celles faites par l'utilisateur (UserCopperList : UCL). Ce
* programme cr donc une UserCopperList qui affichera un dgrad de couleurs
* (faon ciel pseudo couchant).
* Comment faire une copperlist ? Facile : demander de la place pour une 
* structure (au sens C)UserCoperList, l'initialiser avec la fonction qui va bien
* (attention, il faut au moins le systeme 1.3) puis crer les barres de couleurs.
* Les barres se font comme ceci: attendre une position a l'ecran (X maxi=223, 
* Y maxi=233 ),envoyer la couleur (fonction CMove)... On fusionnera ensuite l'UCL
* au View  (ViewPort) courant puis on l'affiche. C'est le systeme qui reserve
* tout seul la place pour la liste. 
* L'instruction CMove attend 3 parametres: l'adresse de l'UCL, le registre 
* (pas forcemment de couleur) a modifier et la couleur a afficher. Ici on 
* touche au registre color00 (color dans le programme), donc a la couleur du
* fond, si l'on dfini CopColor = color+2, on va modifier la couleur "1" donc
* celle de l'ecriture  etc. Attention, le WBench (1.3) utilise 4 registres donc
* modifier le 5eme ne servira a rien. 

	OPT	o+,ow-		; optims maxi, pas de warning

	INCDIR	"Devpac2:include/"
	include	"exec/memory.i"
	include	"exec/exec_lib.i"
	include	"intuition/intuition.i"
	include	"intuition/intuition_lib.i"
	include	"hardware/custom.i"
	include	"graphics/copper.i"
	include	"graphics/graphics_lib.i"
	include	"misc/easystart.i"

NbBarre	equ 24			; nombre de barres et de couleurs
HautBar	equ 8			; hauteur d'une barre
CopColor	equ color		; color = $180 : offset des registres de couleur
 	
*================ Programme Principal ======================
IntLib	lea	IntName(pc),a1	; ouvrir "intuition"
	CALLEXEC	OldOpenLibrary
	move.l	d0,_IntuitionBase	; stocker le pointeur
	beq	NoInt		; pas de librairie ?
GfxLib	lea	GfxName(pc),a1	; ouvrir "graphics"
	moveq	#33,d0		; v33 pour fonction "UCopListInit"
	CALLEXEC	OpenLibrary
	move.l	d0,_GfxBase	; stocker le pointeur
	beq	NoGfx		; pas de graphics ?
OpenWin	lea	WindowDef(pc),a0	; ptr sur definition de la fentre
	CALLINT	OpenWindow	; ouvrir la fenetre
	move.l	d0,WindowPtr	; stocker son pointeur
	beq	NoWin		; ouverture reussie ?
	movea.l	d0,a0		; pour ViewPortAddress(port)
	CALLINT	ViewPortAddress	; chercher ViewPort
	move.l	d0,ViewPortPtr	; stocker le ViewPort de la fenetre

CpLstMem	moveq	#ucl_SIZEOF,d0	; mmoire pour struct UserCopList (12 o)
	move.l	#(MEMF_PUBLIC|MEMF_CLEAR),d1
	CALLEXEC	AllocMem 
	move.l	d0,CopListPtr	; stocker le ptr
	beq	NoCpList		; pas de mmoire ?
InitCopp	movea.l	d0,a0
	moveq	#NbBarre,d0	; # nb barres a Initialiser
	CALLGRAF	UCopperListInit	; initialiser la structure (12 octets)

MakeCL	movea.l	CopListPtr(pc),a2	; adresse de l'UCopList
	movea.l	#Couleurs,a3	; table des couleurs
	moveq	#(NbBarre-1),d2	; nombre de barres a tracer
loop	moveq	#0,d1		; position X pour le Wait
	moveq	#(NbBarre-1),d0	; pour calculer position Y de la barre
	sub.w	d2,d0
	mulu	#HautBar,d0	; Y
	movea.l	a2,a1		; adresse copper liste
CopWAIT	CALLGRAF	CWait		; attendre position x,y
	movea.l	a2,a1
	CALLGRAF	CBump		; passer a la prochaine instruction
	movea.l	a2,a1
	move.w	#CopColor,d0	; offset registre couleur a "copperiser"
	move.w	(a3)+,d1		; charger couleur
CopMOVE	CALLGRAF	CMove		; inclure la nouvelle couleur a la liste
	movea.l	a2,a1
	CALLGRAF	CBump		; passer a la prochaine instruction
	dbf	d2,loop		; boucler tant que tout n'est pas fait
CopEND	move.l	#10000,d0	; attendre 10000eme ligne
	move.l	#$FF,d1		; et 256eme colonne
	movea.l	a2,a1		; les valeurs de d0 & d1 vont
	CALLGRAF	CWait		; terminer la Copperlist

MergeCp	movea.l	ViewPortPtr(pc),a2
	lea	vp_UCopIns(a2),a2	; pour fusion avec notre UCL
	CALLEXEC	Forbid		; interdir le multitche
	move.l	CopListPtr(pc),(a2)	
	CALLEXEC	Permit		; et le remettre
	CALLINT	RethinkDisplay	; afficher notre UCL

WaitWin	movea.l	WindowPtr(pc),a0	; chercher l'UserPort
	movea.l	wd_UserPort(a0),a0
	CALLEXEC	WaitPort		; attendre manifestation utilisateur
	movea.l	WindowPtr(pc),a0	; reprendre l'UserPort
	movea.l	wd_UserPort(a0),a0
	CALLEXEC	GetMsg		; et retirer le message
	movea.l	d0,a1
	CALLEXEC	ReplyMsg		; puis y rpondre
	movea.l	ViewPortPtr(pc),a0
	CALLGRAF	FreeVPortCopLists	; librer l'UserCopperList
	CALLINT	RemakeDisplay	; et refaire l'affichage
		
NoCpList	movea.l	WindowPtr(pc),a0	; fermer la fenetre
	CALLINT	CloseWindow
NoWin	movea.l	_GfxBase(pc),a1	; fermer la "graphics"
	CALLEXEC	CloseLibrary
NoGfx	movea.l	_IntuitionBase(pc),a1
	CALLEXEC	CloseLibrary	; fermer "intuition"
NoInt	moveq	#0,d0		; code de retour
	rts			; adieu 68000

*================= Variables & Donnes =====================		
_IntuitionBase	dc.l 0
_GfxBase		dc.l 0
ViewPortPtr	dc.l 0
WindowPtr	dc.l 0
CopListPtr	dc.l 0	

Couleurs		dc.w $339,$239,$229,$228,$227,$226
		dc.w $225,$226,$227,$228,$238,$239
		dc.w $33a,$33b,$33c,$33d,$54d,$54c
		dc.w $b33,$a33,$932,$732,$521,$421

IntName		dc.b "intuition.library",0
GfxName		dc.b "graphics.library",0,0
WindowTitle	dc.b "CopperList",0
	even
WindowDef	dc.w 10,20,180,10	; x,y,largeur,hauteur 
		dc.b -1,-1	; couleurs titre & cadre
		dc.l CLOSEWINDOW	; flags IDCMP
		dc.l WINDOWCLOSE|RMBTRAP|WINDOWDEPTH|WINDOWDRAG
		dc.l 0
		dc.l 0
		dc.l WindowTitle
		dc.l 0
		dc.l 0
		dc.w -1,-1,-1,-1
		dc.w WBENCHSCREEN
	end
